/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2021-08-04 09:07:37
 * @LastEditors: shimnx
 * @LastEditTime: 2022-07-26 15:08:04
 */
import { Injectable } from '@angular/core';
import {
    CanActivate, Router,
    ActivatedRouteSnapshot,
    RouterStateSnapshot,
    CanActivateChild,
} from '@angular/router';
import { AuthService } from './auth.service';
import { apiList } from '@/app/app.api';
import { selfHttp } from '@/app/http-units.service';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { JwtHelperService } from '@auth0/angular-jwt';
import Base64 from 'base-64'

@Injectable({
    providedIn: 'root',
})
export class AuthGuard implements CanActivate, CanActivateChild {
    userName: string = ''
    theme: string = ''
    myHttpHead: any = {
        headers: new HttpHeaders({ 'Content-Type': 'application/x-www-form-urlencoded', '__tenant': '54A1EF3F-8D68-389B-DE08-3A027E88A19B' }).set('Content-Type', 'application/json')
        .set('Content-Type', 'application/x-www-form-urlencoded')
    }
    url:string
    constructor(private client: HttpClient, private router: Router, private authService: AuthService, private http: selfHttp, public api: apiList,private jwtHelperService:JwtHelperService) {
        console.log(router)
        // this.authService.isLoggedIn = false

        // if(localStorage.getItem('token')){
        //     this.authService.isLoggedIn = true
        // }else{
        //     this.url = this.getQueryUrl('info')
        //     if(this.url){
        //     console.log(JSON.parse(Base64.decode(this.url)))

        //         localStorage.setItem('userInfo', this.url)
        //         localStorage.setItem('token',JSON.parse(Base64.decode(this.url)).token)
        //     }else{
        //         window.location.href = 'https://kimihome.schaefflercn.com'
        //     }
        //     this.authService.isLoggedIn = true
        // }
        this.authService.isLoggedIn = true
        // if (!this.isEmpty(this.GetRequest())) {
        //     // this.accessToken = this.GetRequest().token;
        //     this.userName = this.GetRequest().userName
        //     this.theme = this.GetRequest().theme
        //     this.http.post(this.api.projectList.Authenticate.path, {
        //         "userNameOrEmailAddress": this.userName,
        //         "password": "123qwe",
        //         "rememberClient": false
        //     }, res => {
        //         localStorage.setItem('accessToken', res.result.accessToken)
        //     });
        // }else{
        //     // if(!localStorage.getItem('accessToken')){
        //     //     location.href = 'http://ws003260:6010/'
        //     // }
        // }
    }
    canActivate(next: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean {


        return this.checkPermission();
    }
    canActivateChild(router: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
        return this.canActivate(router, state);
    }
    checkPermission(): boolean {
        if (!this.authService.isLoggedIn) {
            this.router.navigateByUrl('/401');
        }
        return true;
    }
    getQueryUrl(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = window.location.search.substr(1).match(reg);
        if (r != null) return unescape(r[2]); return null;
    }
    isEmpty(obj: object) {
        for (let i in Object.keys(obj)) {
            return false
        }
        return true
    }
    GetRequest() {
        var url = location.search; //获取url中"?"符后的字串
        var theRequest: any = new Object();
        if (url.indexOf("?") != -1) {
            var str = url.substr(1);
            let strs = str.split("&");
            for (var i = 0; i < strs.length; i++) {
                theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
            }
        }
        return theRequest;
    }
}
