/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2021-08-11 09:14:00
 * @LastEditors: shimnx
 * @LastEditTime: 2022-07-14 18:40:35
 */
import { Component, OnInit } from '@angular/core';
import { Router, Routes } from '@angular/router';
import { MyServiceService } from '@/app/my-service.service';
import { TranslateService } from '@ngx-translate/core';
import { ParentService } from '@/app/parent.service';
import { ThemeService } from '@/app/theme.service';
import Base64 from 'base-64'
@Component({
    selector: 'app-scom-navigation-toolbar',
    templateUrl: './scom-navigation-toolbar.component.html',
    styleUrls: ['./scom-navigation-toolbar.component.scss']
})
export class ScomNavigationToolbarComponent implements OnInit {
    currentPath: string = ''
    theme: string = 'Dark'
    userName:string = ""
    constructor(private router: Router,private listsService:MyServiceService,public translate: TranslateService,public ParentService:ParentService,public ThemeService:ThemeService) {
        this.currentPath = this.router.url.substring(this.router.url.lastIndexOf("/") + 1)
        translate.addLangs(["zh", "en"]);
        translate.setDefaultLang('en');
        const browserLang = translate.getBrowserLang();
        translate.use(browserLang.match(/zh|en/) ? browserLang : 'en');
        console.log('translate',translate.store.currentLang)
        if(localStorage.getItem("userInfo")){
            this.userName = JSON.parse(window.decodeURIComponent(Base64.decode(localStorage.getItem("userInfo")))).Name + '(' + JSON.parse(window.decodeURIComponent(Base64.decode(localStorage.getItem("userInfo")))).UserName + ')'
        }
    }
    routers: Routes = (this.router.config[0] as any)!._loadedConfig.routes[0].children;

    ngOnInit() {
        this.getTheme()
        this.routers = this.routers.filter(item => {
            return item.path != ''
        })
    }
    clickSideItem(path) {
        this.currentPath = path
    }
    saveTheme(theme): void {
        console.log(theme)
        localStorage.setItem('theme', theme);
        this.listsService.theme = theme
    }
    englishClick(){
        this.translate.use('zh')
        this.ParentService.emit('zh')
        console.log('translate',this.translate.store.currentLang)
    }
    chineseClick(){
        this.translate.use('en')
        this.ParentService.emit('en')
        console.log('translate',this.translate.store.currentLang)
    }
    /**
     * 获取主题名称并设置到body
     */
    getTheme(): void {
        let theme = localStorage.getItem(`theme`); // 获取主题名称
        if (!theme) {
            theme = `light`; // 本地存储中没有theme的话 使用dark主题
        }
        console.log('切换了切换了切换了')
        localStorage.setItem('theme',theme)
        const body = document.getElementsByTagName('body')[0];
        body.setAttribute('data-theme-style', theme); // 设置data-theme-style 属性
        this.theme = theme; // 用于界面显示
    }
    /**
     * 点击按钮 触发改变主题的方法
     */
    changeTheme(): void {
        const body = document.getElementsByTagName('body')[0];
        if (body.getAttribute(`data-theme-style`) === 'dark') {
            this.saveTheme(`light`); // 保存
            this.ThemeService.emit('light')
            this.getTheme(); // 更新获取
        } else {
          this.ThemeService.emit('dark')
            this.saveTheme(`dark`); // 保存
            this.getTheme(); // 更新获取
        }
    }
}
