/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2021-08-04 09:07:37
 * @LastEditors: shimnx
 * @LastEditTime: 2022-07-26 15:16:33
 */
import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { PagesComponent } from './pages.component';
import { AuthGuard } from '../@core/auth/auth.guard';
import { ScrumBoardComponent } from './scrum-board/scrum-board.component';
const routes: Routes = [{
    path: '',
    component: PagesComponent,
    canActivate: [AuthGuard],
    canActivateChild: [AuthGuard],
    children: [



        {
            path: 'scrum-board',
            component: ScrumBoardComponent,
            data: { icon: 'apps', name: 'SCRUM'}
        },
        {
            path: '',
            redirectTo: 'scrum-board',
            pathMatch: 'full',
        },
    ]
}];

@NgModule({
    imports: [RouterModule.forChild(routes),
],
    exports: [RouterModule]
})
export class LoginRoutingModule { }
