/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2021-08-04 09:07:37
 * @LastEditors: shimnx
 * @LastEditTime: 2022-07-20 13:35:50
 */
import { Component, OnInit } from '@angular/core';
import { Router, Routes } from '@angular/router';
import { AuthService } from '../@core/auth/auth.service';
@Component({
    selector: 'app-pages',
    templateUrl: './pages.component.html',
    styleUrls: ['./pages.component.scss']
})
export class PagesComponent implements OnInit {
    events: string[] = [];
    opened: boolean = true;
    currentPath: string = ''
    centered = false;
    disabled = false;
    unbounded = false;
    radius: number;
    color: string;
    theme: string = 'Dark'
    constructor(private router: Router, private authService: AuthService) {
        this.currentPath = this.router.url.substring(this.router.url.lastIndexOf("/") + 1)
    }
    routers: Routes = (this.router.config[0] as any)!._loadedConfig.routes[0].children;
    ngOnInit() {
        // this.routers = this.routers.splice(1, this.routers.length + 1);
    }
    logout() {
        localStorage.clear()
        this.router.navigateByUrl('/login');
    }
    clickSideItem(path) {
        this.currentPath = path
    }

    saveTheme(theme): void {
        localStorage.setItem(`theme`, theme);
    }

    /**
     * 获取主题名称并设置到body
     */
    getTheme(): void {
        let theme = localStorage.getItem(`theme`); // 获取主题名称
        if (!theme) {
            theme = `dark`; // 本地存储中没有theme的话 使用dark主题
        }
        const body = document.getElementsByTagName('body')[0];
        body.setAttribute('data-theme-style', theme); // 设置data-theme-style 属性
        this.theme = theme; // 用于界面显示
    }
    pageClick(){
        // (window as any).AddProjectPlanComponent.component.confirmPreAcceptance.close()
        // (window as any).AddProjectPlanComponent.component.confirmPreAcceptance()
    }
    /**
     * 点击按钮 触发改变主题的方法
     */
    changeTheme(): void {
        const body = document.getElementsByTagName('body')[0];
        if (body.getAttribute(`data-theme-style`) === 'dark') {
            this.saveTheme(`light`); // 保存
            this.getTheme(); // 更新获取
        } else {
            this.saveTheme(`dark`); // 保存
            this.getTheme(); // 更新获取
        }
    }

}
