/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2021-08-04 09:07:37
 * @LastEditors: shimnx
 * @LastEditTime: 2022-08-02 10:43:01
 */
import { NgModule, CUSTOM_ELEMENTS_SCHEMA, Injectable } from '@angular/core';
import { CommonModule, registerLocaleData } from '@angular/common';

// import { MatDividerModule, MatToolbarModule, MatIconModule, MatButtonModule, MatMenuModule, MatListModule } from '@angular/material';
import { Component } from '@angular/core';
// import { MatTableModule } from '@angular/material'
// import { MatSortModule } from '@angular/material'

import { LoginRoutingModule } from './pages-routing.module';
import { PagesComponent } from './pages.component';
import { MatSidenavModule } from '@angular/material/sidenav';
import { ReactiveFormsModule, FormsModule } from '@angular/forms'
import { MatTreeModule } from '@angular/material/tree';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatRippleModule } from '@angular/material/core';
import { ngfModule } from 'angular-file';
import { MatInputModule } from '@angular/material/input';
import { MatDialogModule } from '@angular/material/dialog';

import { MAT_DIALOG_DEFAULT_OPTIONS } from '@angular/material/dialog';
import { ScomNavigationToolbarComponent } from '../components/scom-navigation-toolbar/scom-navigation-toolbar.component';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatNativeDateModule } from '@angular/material/core';
import { MatFileUploadModule } from 'angular-material-fileupload';
import { MatSnackBar, MAT_SNACK_BAR_DEFAULT_OPTIONS } from '@angular/material/snack-bar';
import { MatSelectModule } from '@angular/material/select';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MtxGridModule } from '@ng-matero/extensions/data-grid'
import { CdkTableModule } from '@angular/cdk/table';
import { MatIconModule } from '@angular/material/icon';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatButtonModule } from '@angular/material/button';
import { IconButtonComponent } from '../components/icon-button/icon-button.component';
import { DefaultButtonComponent } from '../components/default-button/default-button.component';
import { MatCardModule } from '@angular/material/card';
import { MatTabsModule } from '@angular/material/tabs';
import { NzTableModule } from 'ng-zorro-antd/table';
import { NzProgressModule } from 'ng-zorro-antd/progress';
import { MatChipsModule } from '@angular/material/chips';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { HighchartsChartModule } from 'highcharts-angular';

import { MatTooltipModule } from '@angular/material/tooltip';
import { TeamServiceService } from '../serve/team-service.service';
import { MatMenuModule } from '@angular/material/menu';
import { HttpClient, HttpResponse } from '@angular/common/http';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatRadioModule } from '@angular/material/radio';
import {
    TranslateModule,
    TranslateLoader,
    TranslateService
} from '@ngx-translate/core';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';

import { HTTP_INTERCEPTORS } from '@angular/common/http';
import { MatTableModule } from '@angular/material/table';
import { MatPaginatorModule } from '@angular/material/paginator';
import {
    HttpEvent,
    HttpInterceptor,
    HttpHandler,
    HttpRequest,
} from '@angular/common/http';
import { tap } from 'rxjs/operators';
import { Observable } from 'rxjs';

import { SnackbarComponent } from './snackbar/snackbar.component';
import { Router } from '@angular/router';
import { BsDatepickerModule } from 'ngx-bootstrap/datepicker';
import { NzDatePickerModule } from 'ng-zorro-antd/date-picker';
import en from '@angular/common/locales/en';
import zh from '@angular/common/locales/zh';
import { BryntumTaskBoardModule } from '@bryntum/taskboard-angular';

import { NzSelectModule } from 'ng-zorro-antd/select';
import { NZ_I18N, en_US,zh_CN } from 'ng-zorro-antd/i18n'
import { MatFormFieldModule } from '@angular/material/form-field';
import { ScrumBoardComponent } from './scrum-board/scrum-board.component';
registerLocaleData(zh);
// import { SlateModule } from 'slate-angular';
export function createTranslateLoader(http: HttpClient) {
    return new TranslateHttpLoader(http, '../../assets/i18n/', '.json');
}
export class AddHeaderInterceptor implements HttpInterceptor {
    intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
        // Clone the request to add the new header
        const clonedRequest = req.clone({ headers: req.headers.set('Authorization', 'Bearer ' + localStorage.getItem('token')) });

        // Pass the cloned request instead of the original request to the next handle
        return next.handle(clonedRequest);
    }
}
@Injectable()
export class NotificationInterceptor implements HttpInterceptor {
    constructor(private _snackBar: MatSnackBar) { }
    router: Router;
    intercept(req: HttpRequest<any>, next: HttpHandler) {
        // 对响应消息进行处理
        if (localStorage.getItem('token')) {
            let strings = localStorage.getItem('token').split("."); //截取token，获取载体
            var userinfo = JSON.parse(decodeURIComponent(window.atob(strings[1].replace(/-/g, "+").replace(/_/g, "/"))))
            var timestamp = new Date().getTime()

            if (timestamp > userinfo.exp * 1000) {
                localStorage.clear()
                location.reload()
            }

        }

        return next.handle(req).pipe(

            tap((event: HttpEvent<any>) => {

                if (
                    event instanceof HttpResponse &&
                    event.status >= 200 &&
                    event.status < 300
                ) {
                }
            },
                error => {
                    this._snackBar.openFromComponent(SnackbarComponent, {
                        data: { message: error.error.message || error.error.Message, action: 'error', },
                        verticalPosition: 'top',
                        panelClass: ['red-snackbar']
                    });

                    if (error.status == 403 || error.status == 401) {
                        window.location.href = 'https://kimihome.schaefflercn.com'


                    }
                    if (error.error.Message == "IDX10501: Signature validation failed. Unable to match key: \nkid: 'System.String'.\nExceptions caught:\n 'System.Text.StringBuilder'. \ntoken: 'System.IdentityModel.Tokens.Jwt.JwtSecurityToken'.") {

                        window.location.href = 'https://kimihome.schaefflercn.com'

                    }
                }
            )
        );
    }

}
@NgModule({
    schemas: [CUSTOM_ELEMENTS_SCHEMA],
    declarations: [
        PagesComponent,
        ScomNavigationToolbarComponent,
        IconButtonComponent,
        DefaultButtonComponent,
        ScrumBoardComponent,

    ],
    imports: [
        // SlateModule,
        NzSelectModule,
        BryntumTaskBoardModule,
        BsDatepickerModule.forRoot(),
        MatSlideToggleModule,
        NzDatePickerModule,
        MatFormFieldModule,
        MatPaginatorModule,
        MatRadioModule,
        MatMenuModule,
        MatTableModule,
        MatTooltipModule,
        NzTableModule,
        HighchartsChartModule,
        ngfModule,
        MatNativeDateModule,
        MatChipsModule,
        MatAutocompleteModule,
        MatIconModule,
        MatDatepickerModule,
        MatTabsModule,
        CdkTableModule,
        MtxGridModule,
        MatCardModule,
        MatToolbarModule,
        MatProgressBarModule,
        MatProgressSpinnerModule,
        MatDialogModule,
        MatFileUploadModule,
        MatRippleModule,
        MatSelectModule,
        LoginRoutingModule,
        CommonModule,
        MatButtonModule,
        MatSidenavModule,
        ReactiveFormsModule,
        FormsModule,
        MatCheckboxModule,
        MatTreeModule,
        MatInputModule,
        NzProgressModule,
        TranslateModule.forRoot({
            loader: {
                provide: TranslateLoader,
                useFactory: createTranslateLoader,
                deps: [HttpClient]
            }
        })
    ],
    entryComponents: [],
    bootstrap: [PagesComponent],
    providers: [
        TeamServiceService,
        {
            provide: HTTP_INTERCEPTORS,
            useClass: AddHeaderInterceptor,
            multi: true,
        },
        {
            provide: NZ_I18N,
            useValue:zh_CN
        },
        {
            provide: HTTP_INTERCEPTORS,
            useClass: NotificationInterceptor,
            multi: true
        },
        { provide: MAT_DIALOG_DEFAULT_OPTIONS, useValue: { hasBackdrop: true } },
        { provide: MAT_SNACK_BAR_DEFAULT_OPTIONS, useValue: { duration: 0 } }
    ]
})
export class PagesModule { }
