/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2022-07-26 15:15:31
 * @LastEditors: shimnx
 * @LastEditTime: 2022-08-02 15:30:12
 */
import { Component, ElementRef, OnInit, ViewChild } from '@angular/core';
import { BryntumTaskBoardComponent, BryntumProjectModelComponent } from '@bryntum/taskboard-angular';
import { taskBoardConfig, projectConfig } from '../app.config';
import { Button, TaskBoard, Toast, MessageDialog, StringHelper } from '@bryntum/taskboard';
import { Observable } from 'rxjs';
import { map, startWith } from 'rxjs/operators';
import {FormGroup, FormControl} from '@angular/forms';
@Component({
    selector: 'app-scrum-board',
    templateUrl: './scrum-board.component.html',
    styleUrls: ['./scrum-board.component.scss']
})
export class ScrumBoardComponent implements OnInit {
    taskData = {
        tasksData: [
          { id: 1, name: 'My first task', "progress": 45, status: 'Todo', "prio": "medium", date: "2022-08-01", group: 'GroupA', dailyTask: 1, action: 3 , 'assigner':'Wang, Fang OP/TCG-ZSI' },
          { id: 2, name: 'My second task', "progress": 45, status: 'Todo', "prio": "high", date: "2022-02-01", group: 'GroupA', dailyTask: 1, action: 3 , 'assigner':'Ren, Fang OP/TCG-ZSI' }
        ],
        resourcesData:[
          { id : 1, name : 'Angelo', image : '' },
          { id : 2, name : 'Celia', image : 'celia.jpg' },
          { id : 3, name : 'Dave', image : 'dave.jpg' },
          { id : 4, name : 'Emilia', image : 'emilia.jpg' },
          { id : 5, name : 'Gloria', image : 'gloria.jpg' },
          { id : 6, name : 'Ren, Fang(OP/TCG-ZSI)' },
          { id : 7, name : 'Wang, Fang(OP/TCG-ZSI)' },
          { id : 8, name : 'Lee', image : 'lee.jpg' },
          { id : 9, name : 'Lisa', image : 'lisa.jpg' },
          { id : 10, name : 'Mark', image : 'mark.jpg' },
          { id : 11, name : 'Steve', image : 'steve.jpg' }
        ],
        assignmentsData:[
          { id : 1, event : 7, resource : 1 },
            { id : 2, event : 7, resource : 2 },
            { id : 3, event : 8, resource : 2 },
            { id : 4, event : 4, resource : 3 },
            { id : 5, event : 7, resource : 3 },
            { id : 6, event : 7, resource : 4 },
            { id : 7, event : 7, resource : 5 },
            { id : 8, event : 7, resource : 6 },
            { id : 9, event : 7, resource : 7 },
            { id : 10, event : 7, resource : 8 },
            { id : 11, event : 7, resource : 9 },
            { id : 12, event : 7, resource : 10 },
            { id : 13, event : 7, resource : 11 },
            { id : 14, event : 16, resource : 7 },
            { id : 15, event : 16, resource : 8 },
            { id : 16, event : 16, resource : 9 },
            { id : 17, event : 16, resource : 10 },
            { id : 18, event : 16, resource : 11 },
            { id : 19, event : 19, resource : 10 },
            { id : 20, event : 9, resource : 7 },
            { id : 21, event : 12, resource : 8 },
            { id : 22, event : 14, resource : 9 },
            { id : 23, event : 17, resource : 10 },
            { id : 24, event : 18, resource : 10 },
            { id : 25, event : 11, resource : 9 },
            { id : 26, event : 20, resource : 8 },
            { id : 27, event : 1, resource : 7 },
            { id : 28, event : 2, resource : 6 },
            { id : 29, event : 5, resource : 5 },
            { id : 30, event : 6, resource : 4 },
            { id : 31, event : 10, resource : 3 },
            { id : 32, event : 15, resource : 2 },
            { id : 33, event : 3, resource : 1 },
            { id : 34, event : 13, resource : 2 },
            { id : 35, event : 21, resource : 3 },
            { id : 36, event : 8, resource : 3 },
            { id : 37, event : 17, resource : 9 },
            { id : 38, event : 17, resource : 8 },
            { id : 39, event : 17, resource : 7 },
            { id : 40, event : 17, resource : 6 }
        ]
      }
    private taskboard: TaskBoard;
    taskBoardConfig = taskBoardConfig;
    projectConfig = projectConfig;
    @ViewChild('drawer') drawer:ElementRef;
    @ViewChild('taskboard') taskBoardComponent!: BryntumTaskBoardComponent;
    @ViewChild('project') projectComponent!: BryntumProjectModelComponent;
    @ViewChild(BryntumTaskBoardComponent, { static: false }) taskboardComponent: BryntumTaskBoardComponent;
    projectControl = new FormControl('');
    memberControl = new FormControl('');
    groupControl = new FormControl('');
    projectOptions: Observable<string[]>;
    memberOptions: Observable<string[]>;
    groupOptions: Observable<string[]>;
    projectOption: string[] = ['One', 'Two', 'Three'];
    memberOption: string[] = ['One', 'Two', 'Three'];
    groupOption: string[] = ['One', 'Two', 'Three'];
    range = new FormGroup({
        start: new FormControl(null),
        end: new FormControl(null),
    });
    projectTask:string = ''
    Priority:string = ''
    Priorities:any = ['low','medium','high']
    selectedPrio:string = 'low'
    constructor() {
        window['ScrumBoardComponent'] = { component: this };
    }

    ngOnInit(): void {
        this.projectOptions = this.projectControl.valueChanges.pipe(
            startWith(''),
            map(value => this._filter(value || '')),
        );
        this.memberOptions = this.memberControl.valueChanges.pipe(
            startWith(''),
            map(value => this._filter1(value || '')),
        );
        this.groupOptions = this.groupControl.valueChanges.pipe(
            startWith(''),
            map(value => this._filter2(value || '')),
        );
    }
    private _filter(value: string): string[] {
        const filterValue = value.toLowerCase();

        return this.projectOption.filter(option => option.toLowerCase().includes(filterValue));
    }
    private _filter1(value: string): string[] {
        const filterValue = value.toLowerCase();

        return this.memberOption.filter(option => option.toLowerCase().includes(filterValue));
    }
    private _filter2(value: string): string[] {
        const filterValue = value.toLowerCase();

        return this.groupOption.filter(option => option.toLowerCase().includes(filterValue));
    }
    ngAfterViewInit(): void {
        this.taskboard = this.taskboardComponent.instance;
        this.taskboard.on('taskDrag', this.taskDrag.bind(this))
        this.initTaskData()
        console.log(this.taskboard.features)
        this.taskboard.features['columnHeaderMenu'].disabled = true
    }
    taskDrag({ source, taskRecords, targetColumn, targetSwimlane }): boolean {
        console.log(source, taskRecords, targetColumn, targetSwimlane)
        return true
    }
    initTaskData() {
        (this.taskboard.project as any).loadInlineData(this.taskData)
    }
    openDrawer(){
        (this.drawer as any).toggle()
    }
    searchProject(){

    }
    clearCode(){

    }
    changePriority(e){
        console.log(e.value)
        // I want to change the value in the card here
    }
}
